Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| ESC/Java2 © 2003,2004,2005 David Cok and Joseph Kiniry © 2005 UCD Dublin © 2003,2004 Radboud University Nijmegen © 1999,2000 Compaq Computer Corporation © 1997,1998,1999 Digital Equipment Corporation All Rights Reserved
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## escjava.translate
Class Suggestion

    java.lang.Object
      escjava.translate.Suggestion

class Suggestion
extends java.lang.Object

This class generates possible ways to annotate a program to eliminate a given warning.

NOTE: The syntax of the strings produced in this class must be kept in sync with what is expected by the script wizfilter.perl.

Constructor Summary
`(package private)` | `Suggestion()`

Method Summary
`private static boolean` | `brokenObjIsMadeUp(SList cc)`
`private static Set` | `checkNaryExpr(NaryExpr e)`
`private static java.lang.String` | `gArrStore(VarInit E, RoutineDecl rd)`
`(package private) static java.lang.String` | `generate(int warningTag, java.lang.Object auxInfo, RoutineDecl rd, Set directTargets, SList cc, int locDecl)`
`(package private) static MethodDecl` | `getOriginalMethod(MethodDecl md)` Returns a method that `md` overrides.
`private static java.lang.String` | `gInvariant(Expr E, RoutineDecl rd, SList cc, int locDecl)`
`private static java.lang.String` | `gNeg(VarInit E, RoutineDecl rd, Set directTargets)`
`private static java.lang.String` | `gNull(VarInit E, RoutineDecl rd)`
`private static java.lang.String` | `name(Identifier id, int loc)`
`private static Set` | `possiblyInjectiveFields(Expr e)`
`private static java.lang.String` | `typeName(Type type)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Suggestion

    Suggestion()

Method Detail

### generate

    static java.lang.String generate(int warningTag,
                                     java.lang.Object auxInfo,
                                     RoutineDecl rd,
                                     Set directTargets,
                                     SList cc,
                                     int locDecl)

### gNull

    private static java.lang.String gNull(VarInit E,
                                          RoutineDecl rd)

### gNeg

    private static java.lang.String gNeg(VarInit E,
                                         RoutineDecl rd,
                                         Set directTargets)

### gArrStore

    private static java.lang.String gArrStore(VarInit E,
                                              RoutineDecl rd)

### gInvariant

    private static java.lang.String gInvariant(Expr E,
                                               RoutineDecl rd,
                                               SList cc,
                                               int locDecl)

### getOriginalMethod

    static MethodDecl getOriginalMethod(MethodDecl md)

  Returns a method that `md` overrides. If `md` overrides a method in a class, then that method is returned. Otherwise, any one of the overrides is returned.

### name

    private static java.lang.String name(Identifier id,
                                         int loc)

### typeName

    private static java.lang.String typeName(Type type)

### brokenObjIsMadeUp

    private static boolean brokenObjIsMadeUp(SList cc)

### possiblyInjectiveFields

    private static Set possiblyInjectiveFields(Expr e)

### checkNaryExpr

    private static Set checkNaryExpr(NaryExpr e)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| ESC/Java2 © 2003,2004,2005 David Cok and Joseph Kiniry © 2005 UCD Dublin © 2003,2004 Radboud University Nijmegen © 1999,2000 Compaq Computer Corporation © 1997,1998,1999 Digital Equipment Corporation All Rights Reserved
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

The ESC/Java2 Project Homepage